#ifndef KEYS_H
#define KEYS_H
/* The control keys are wrong when not using Qwerty. Thankfully, they have
 * unique ASCII characters that can be used to identify them.
 */

#define CTRL_2		((KEY_2<<8) | 0x00)
#define CTRL_6		((KEY_6<<8) | 0x1e)

#define CTRL_KEY(k) (((k)&0xff) - 'A' + 1)
#define IS_CTRL_KEY(k,c)	(((k)&0xff) == CTRL_KEY(c))
//#define IS_CTRL_KEY(k,c)	(key[KEY_CTRL] && ((k)&0xff) == CTRL_KEY(c))


#define CTRL_A		((KEY_A<<8) | 0x01)
#define CTRL_B		((KEY_B<<8) | 0x02)
#define CTRL_C		((KEY_C<<8) | 0x03)
#define CTRL_D		((KEY_D<<8) | 0x04)
#define CTRL_E		((KEY_E<<8) | 0x05)
#define CTRL_F		((KEY_F<<8) | 0x06)
#define CTRL_G		((KEY_G<<8) | 0x07)
#define CTRL_H		((KEY_H<<8) | 0x08)
#define CTRL_I		((KEY_I<<8) | 0x09)
#define CTRL_J		((KEY_J<<8) | 0x0a)
#define CTRL_K		((KEY_K<<8) | 0x0b)
#define CTRL_L		((KEY_L<<8) | 0x0c)
#define CTRL_M		((KEY_M<<8) | 0x0d)
#define CTRL_N		((KEY_N<<8) | 0x0e)
#define CTRL_O		((KEY_O<<8) | 0x0f)
#define CTRL_P		((KEY_P<<8) | 0x10)
#define CTRL_Q		((KEY_Q<<8) | 0x11)
#define CTRL_R		((KEY_R<<8) | 0x12)
#define CTRL_S		((KEY_S<<8) | 0x13)
#define CTRL_T		((KEY_T<<8) | 0x14)
#define CTRL_U		((KEY_U<<8) | 0x15)
#define CTRL_V		((KEY_V<<8) | 0x16)
#define CTRL_W		((KEY_W<<8) | 0x17)
#define CTRL_X		((KEY_X<<8) | 0x18)
#define CTRL_Y		((KEY_Y<<8) | 0x19)
#define CTRL_Z		((KEY_Z<<8) | 0x1a)

#ifdef DELETE
#undef DELETE
#endif

#define ESCAPE		((KEY_ESC<<8)    | 0x1b)
#define ENTER		((KEY_ENTER<<8)  | 0x0d)
#define MINUS		((KEY_MINUS<<8)  | 0x2d)	// Not keypad
#define PAGEUP		((KEY_PGUP<<8)   | 0x00)
#define PAGEDOWN	((KEY_PGDN<<8)   | 0x00)
#define HOME		((KEY_HOME<<8)   | 0x00)
#define END			((KEY_END<<8)    | 0x00)
#define INSERT		((KEY_INSERT<<8) | 0x00)
#define DELETE		((KEY_DEL<<8)    | 0x00)
#define CURS_UP		((KEY_UP<<8)     | 0x00)
#define CURS_DOWN	((KEY_DOWN<<8)   | 0x00)
#define CURS_LEFT	((KEY_LEFT<<8)   | 0x00)
#define CURS_RIGHT	((KEY_RIGHT<<8)  | 0x00)
#define TAB			((KEY_TAB<<8)    | 0x09)

#define F1			(KEY_F1<<8)
#define F2          (KEY_F2<<8)
#define F3          (KEY_F3<<8)
#define F4          (KEY_F4<<8)
#define F5          (KEY_F5<<8)
#define F6          (KEY_F6<<8)
#define F7          (KEY_F7<<8)
#define F8          (KEY_F8<<8)
#define F9          (KEY_F9<<8)
#define F10         (KEY_F10<<8)
#define F11         (KEY_F11<<8)

/*#define SHIFT_F1	0x5400
#define SHIFT_F2	0x5500
#define SHIFT_F3	0x5600
#define SHIFT_F4	0x5700
#define SHIFT_F5	0x5800
#define SHIFT_F6	0x5900
#define SHIFT_F7	0x5a00
#define SHIFT_F8	0x5b00
#define SHIFT_F9	0x5c00
#define SHIFT_F10	0x5d00*/

#define SHIFT_C		((KEY_C<<8) | 'C')// 0x43)
#define SHIFT_E		((KEY_E<<8) | 'E')// 0x45)
#define SHIFT_F		((KEY_F<<8) | 'F')// 0x46)

#ifdef MOD_ALT
#undef MOD_ALT
#endif

#define MOD_RSHIFT	KB_SHIFT_FLAG
#define MOD_LSHIFT  KB_SHIFT_FLAG
#define MOD_CTRL    KB_CTRL_FLAG
#define MOD_ALT     KB_ALT_FLAG
#define MOD_SCROLL  KB_SCROLOCK_FLAG
#define MOD_NUMLOCK KB_NUMLOCK_FLAG
#define MOD_CAPS    KB_CAPSLOCK_FLAG
#define MOD_INSERT  KB_INSERT_FLAG

#ifdef MOD_SHIFT
#undef MOD_SHIFT
#endif

#define MOD_SHIFT	(MOD_RSHIFT|MOD_LSHIFT)

#endif	// KEYS_H
